Subject: [mpls] MPLS-RT review of draft-bryant-mpls-sfl-control

From: Tarek Saad <[email-masked]>
Date: Fri, 3 Jan 2020 18:43:32 +0000

Hi,

I’ve been selected as an MPLS-RT reviewer for this draft being considered for WG adoption.
After reading it, I have the following comments on it:

1. Since the SFL control protocol uses ACH – the SFL control messages flow in-band over the MPLS datapath (e.g. PW, LSP, etc.). Is this restriction required? How does it differ from other protocol(s) that do out-of-band control messaging -- e.g. BGP, T-LDP, etc. that allocate PW labels?
2. It would be useful to have text for any considerations/comparison given to existing control plane protocols that can do same/similar function and if/why they are not adopted/extended
3. Section 3 mentions, the SFL ACH can be carried over PW, or LSP. What about MPLS section/i.e. MPLS link? E.g. for use with single-hop LM? Any restrictions for this?
4. Section 3.1:
	a. Some flags may be meaningful at one side (i.e. either querier or responder) and depending if CC flag is R set or not -- some flags may be invalid if received - e.g. W Lflag is not expected to be received by a querier. Do such cases necessitate errors? How is it handled - rejecting the whole SFL batch or the whole SFL message?
	b. s/Responser/Responder
5. Section 3.2.1
	a. May clarify that “SFL Control Request” message, is “SFL Control Message” with CC Flag (R=1)
	b. Can the same message serve as Request, Refresh and Withdraw for a specific Batch? i.e. to allow existing (allocated) SFL batch to be resized by refreshing some existing SFL(s), withdrawing some, and requesting some new ones? If yes, may clarify it - since as-is the sections defined in the document hint that a message can be one of (request/refresh/withdraw) at any time
	c. In cases where a  node functions as both requester and responder, can same session Id be used for sending requests and respond by the same node?
	d. As per https://tools.ietf.org/html/draft-ietf-mpls-sfl-framework, the high runner case for SFL is for additional action packet counter - is this action assumed implicit always for all SFL(s)? Is there a way in the protocol to associate different/additional action with a specific SFL?
	e. “A Querier MUST NOT send an expired SFL to a Responder since to do so may invalidate another SFL operation.”: this may be considered a security for a DoS, you may want to highlight this in the security section
	f. s/SFV/SFL
	g. The text “All other LFlags are cleared.” Seem to override the previous text that. V LFlag can be also set at same time to cover requesting a specific label
6. For unidirectional LSP(s), how is the return path for response messages specified? Is the Querier source address derived from LSP control plane state? Or, is the SA TLV from RFC6374 for p2p unidirectional added too? In this case, how to force the SFL Control Response message – e.g. be IP routed back or go over a specific reverse LSP?
7. "3.2.3.  Withdraw  
           [...] via an appropriate path.", does this mean control messages can be sent over any path (other than the underlying LSP or PW)?
8. "
   A Querier MUST wait a configured time (suggested wait of 60 seconds)
   before reattempting a Withdraw request.", may be useful to highlight why the restriction? Is this to avoid frequent sending of control plane messaging?

Regards,
Tarek

---

From: Tarek Saad <[email-masked]>
Date: Wed, 8 Jan 2020 21:11:38 +0000

Hi authors,

Again, thanks for working on this document.

For completeness of my review, please see inline for the comments I expect be concluded before the document is adopted.

On 1/3/20, 1:43 PM, "Tarek Saad" <[email-masked]> wrote:

    Hi,

    1. Since the SFL control protocol uses ACH – the SFL control messages flow in-band over the MPLS datapath (e.g. PW, LSP, etc.). Is this restriction required? How does it differ from other protocol(s) that do out-of-band control messaging -- e.g. BGP, T-LDP, etc. that allocate PW labels?
    2. It would be useful to have text for any considerations/comparison given to existing control plane protocols that can do same/similar function and if/why they are not adopted/extended
[TS]: I'm OK to defer adding the text to the document on this. Howver, it'll be very useful to have your initial thoughts on this shared on the list so the WG has better understanding why the proposal is more favorable/suitable.

For the remaining points below, I think these can be addressed after WG adopts the document.

Regards,
Tarek

    4. Section 3.1:
    
    Regards,
    Tarek